$!-----------------------------------------------------------------------------
$! BUILD_CLIENT_CERT_CA_FILE.COM
$!
$! Copy all [.CERTS]*.PEM files concatentaing their contents into
$! [.WASD]CLIENT_CAFILE.TXT.  Each file has a preceding comment with the name
$! of the file it was deribed from.
$!
$! 20-DEC-2000  MGD  initial
$!-----------------------------------------------------------------------------
$!
$ say = "write sys$output"
$ procedure = f$environment("procedure") - "000000."
$ newDefault = f$parse(procedure,,,"device") + f$parse(procedure,,,"directory")
$ prevDefault = f$environment("default")
$ set default 'newDefault'
$!
$ on controly then goto cleanup
$ on error then goto cleanup
$!
$ write sys$output "Building CLIENT_CERT_CA_FILE.TXT"
$!
$ open /write /error=openCAfileError CAfile CLIENT_CERT_CA_FILE.TXT
$ openCAfileError:
$ openStatus = $STATUS
$ if .not. openStatus then exit openStatus
$ write CAfile "# Client Verification CA File"
$ write CAfile "# created by " + f$element(0,";",f$environment("procedure"))
$ write CAfile "#         on " + f$time()
$!
$ searchLoop:
$!
$    fileName = f$search("[-.CERTS]*.PEM")
$    if fileName .eqs. "" then goto searchLoopEnd
$    call processPEMfile 'fileName'
$    goto searchLoop
$!
$ searchLoopEnd:
$!
$ call processPEMfile "''f$search("[.CERT]_CACERT.PEM")'" "WASD CA cert"
$!
$ write CAfile ""
$ write CAfile "# end"
$!
$ cleanup:
$ if f$trnlnm("PEMfile","LNM$PROCESS") .nes. "" then close PEMfile
$ if f$trnlnm("CAfile","LNM$PROCESS") .nes. "" then close CAfile
$!
$ set default 'prevDefault'
$ exit
$!
$!-----------------------------------------------------------------------------
$!
$ processPEMfile: subroutine
$!
$ on controly then goto processPEMfileEnd
$ on error then goto processPEMfileEnd
$ fileName = P1
$ comment = P2
$ if comment .eqs. "" then comment = f$parse(fileName,,,"name") + ".PEM"
$ write sys$output "Processing " + fileName
$ open /read /error=openPemFileError PEMfile 'fileName'
$ openPemFileError:
$ openStatus = $STATUS
$ if .not. openStatus
$ then
$    write caFile "# ERROR: could not open ''fileName', ''openStatus'"
$    write caFile "#        " + f$message(openStatus);
$    goto processPemFileEnd
$ endif
$ searchCertLoop:
$    read /error=searchCertLoopEnd /end=searchCertLoopEnd PEMfile line
$    if f$locate("----BEGIN CERTIFICATE----",line) .ges. f$length(line) -
        then goto searchCertLoop
$ searchCertLoopEnd:
$ if f$locate("----BEGIN CERTIFICATE----",line) .ges. f$length(line) -
     then goto processPemFileEnd
$ write sys$output "Adding " + f$parse(fileName,,,"name") + ".PEM"
$ write CAfile ""
$ write CAfile "# " + comment
$ write CAfile ""
$ write CAfile line
$ writeCertLoop:
$    read /error=writeCertLoopEnd /end=writeCertLoopEnd PEMfile line
$    write CAfile line
$    if f$locate("----END CERTIFICATE----",line) .ges. f$length(line) -
        then goto writeCertLoop
$ writeCertLoopEnd:
$ processPemFileEnd:
$ close PEMfile
$!
$ exit
$ endsubroutine
$!
$!-----------------------------------------------------------------------------
